# -*- coding: utf-8 -*-
import json
import re
import socket
from pprint import pprint as print
from urllib.parse import urlparse, quote

info_path = 'x:\info.txt'  # 改成对应的info.txt路径
information_path = 'x:\information.txt'  # 改成对应的information.txt路径
url = 'http://122.10.6.28/dingfeng/admin.php/Apiserver/put_server_hardware'
# url = 'http://127.0.0.1:5000/data'  # 改成对应接口


def post_form(url, json_data):
    '''简单封装post'''
    try:
        socket.setdefaulttimeout(1)
        url = urlparse(url)
        host = url.netloc
        path = url.path
        json_str = json.dumps(json_data, ensure_ascii=False)
        if path == "":
            path = "/"
        send_data = 'data=' + quote(json_str)
        strPost = "POST {0} HTTP/1.1\r\nHost: {1}\r\nContent-Type: application/x-www-form-urlencoded\r\nConnection: close\r\nCache-Control: no-cache\r\nContent-Length: {2}\r\n\r\n".format(path, host, len(send_data))
        strPost += send_data
        # print(strPost)
        # 建立socket连接
        # print(strPost)
        client = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        client.connect((host.split(':', 1)[0], 80 if len(host.split(':', 1)) == 1 else int(host.split(':', 1)[1])))
        # client.connect(('127.0.0.1', 5000))
        client.sendall(strPost.encode('utf-8'))
    except socket.timeout:
        raise Exception('超时')


def post_json(url, json_data):
    '''简单封装post'''
    try:
        socket.setdefaulttimeout(1)
        url = urlparse(url)
        host = url.netloc
        path = url.path
        json_str = json.dumps(json_data)
        if path == "":
            path = "/"
        send_data = json_str
        strPost = "POST {0} HTTP/1.1\r\nHost: {1}\r\nContent-Type: application/json\r\nConnection: close\r\nCache-Control: no-cache\r\nContent-Length: {2}\r\n\r\n".format(path, host, len(send_data))
        strPost += send_data
        # print(strPost)
        # 建立socket连接
        # print(strPost)
        client = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        client.connect((host.split(':', 1)[0], 80 if len(host.split(':', 1)) == 1 else int(host.split(':', 1)[1])))
        # client.connect(('127.0.0.1', 5000))
        client.sendall(strPost.encode('utf-8'))
    except socket.timeout:
        raise Exception('超时')


def get_raw_data(file, encoding='utf-8'):
    '''读取原始数据'''
    try:
        with open(file, 'r', encoding=encoding) as f:
            raw_data = f.read()
            return raw_data
    except Exception as e:
        raise Exception('读取文件失败 ' + repr(e))


def deal_info():
    try:
        raw_data = get_raw_data(info_path, encoding='gbk')
        # 根据---BBU 状态------------------------------------正则分隔大分类
        json_data = {}
        bc_list = re.split(r'---(.*?)------------------------------------', raw_data)[1:]
        for bc_title, bc_info in [(bc_list[i].strip(), bc_list[i+1]) for i in range(0, len(bc_list), 2)]:
            if bc_title:
                bc_info_dict = {}
                json_data[bc_title] = bc_info_dict
                for info in re.split(r'\r?\n', bc_info):
                    if info and not info.isspace():
                        key, value = info.split(':', 1)
                        key, value = key.strip(), value.strip()
                        if key in bc_info_dict:
                            # 如果在自动转列表
                            tmp = bc_info_dict[key]
                            del bc_info_dict[key]
                            bc_info_dict[key + ' list'] = [tmp, value]
                        elif (key + ' list') in bc_info_dict:
                            # 判断列表存在直接添加
                            bc_info_dict[key + ' list'].append(value)
                        else:
                            bc_info_dict[key] = value
        return json_data
    except Exception as e:
        return {'error': '处理info.txt错误 ' + repr(e)}


# def deal_information():
#     try:
#         raw_data = get_raw_data(information_path, encoding='UTF-16')
#         print(raw_data.encode())
#         json_data = {}
#         # 根据Caption=Microsoft Windows Server 2008 R2 Enterprise 正则分隔大分类
#         bc_list = re.split(r'Caption=(.*?)\r?\n', raw_data)[1:]
        # for bc_title, bc_info in [(bc_list[i].strip(), bc_list[i+1]) for i in range(0, len(bc_list), 2)]:
        #     if bc_title:
        #         bc_info_dict = {}
        #         if (bc_title + '_list') in json_data:
        #             # 如果存在改分类列表自动添加
        #             json_data[(bc_title + ' list')].append(bc_info_dict)
        #         elif bc_title in json_data:
        #             # 如果存在就转化为列表
        #             json_data[(bc_title + ' list')] = [json_data[bc_title], bc_info_dict]
        #             del json_data[bc_title]
        #         else:
        #             json_data[bc_title] = bc_info_dict
        #         for info in re.split(r'\r?\n', bc_info):
        #             if info and not info.isspace():
        #                 key, value = info.split('=', 1)
        #                 bc_info_dict[key.strip()] = value.strip()
        # return json_data
    # except Exception as e:
    #     return {'error': '处理information.txt错误 ' + repr(e)}


def deal_information():
    try:
        raw_data = get_raw_data(information_path, encoding='UTF-16')
        # print(raw_data.encode())
        json_data = []
        # 根据Caption=Microsoft Windows Server 2008 R2 Enterprise 正则分隔大分类
        bc_list = re.split(r'\n{4,}', raw_data)
        for bc_info in bc_list:
            if bc_info:
                tmp = []
                json_data.append(tmp)
                for sc_info in bc_info.split('\n\n\n'):
                    if sc_info:
                        info_dict = {}
                        tmp.append(info_dict)
                        for info in sc_info.split('\n'):
                            if info:
                                key, value = info.split('=')
                                info_dict[key.strip()] = value.strip()
        return json_data
    except Exception as e:
        return {'error': '处理information.txt错误 ' + repr(e)}


if __name__ == '__main__':
    try:
        info_data = deal_info()
        information_data = deal_information()
        post_form(url, {'info': info_data, 'information': information_data})
    except Exception as e:
        post_form(url, {'error': '异常 ' + repr(e)})
